package net.sf.jsequnit.javadoc;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.sun.javadoc.Tag;

/**
 * @author jacek.ratzinger
 *
 */
class TagParser {
	
	private static final String VALUE_SEPARATOR = ",";
	
	private Tag tag;

	public TagParser(Tag tag) {
		this.tag = tag;
	}
	
	public String getParamValue(String paramName) {
		Pattern paramPattern = Pattern.compile(paramName + "=(\\S+)");
		Matcher paramMatcher = paramPattern.matcher(tag.text());
		if (paramMatcher.find()) {
			return paramMatcher.group(1);
		}
		return null;
	}
	
	public List<String> getParamValues(String paramName) {
		String paramValueList = getParamValue(paramName);
		if (paramValueList == null) return new ArrayList<String>();
		String[] result = paramValueList.split(VALUE_SEPARATOR);
		return Arrays.asList(result);
	}
	
	public boolean paramExist(String paramName) {
		return tag.text().contains(paramName);
	}

}
